com.ihr.xbrl.pojo

## Class XBRLRSGenerator

- java.lang.Object
- - com.ihr.xbrl.pojo.XBRLRSGenerator

-     public class XBRLRSGenerator
      extends java.lang.Object

  Generates an object based on the com.ihr.xbrl.om object model from an object in the com.ihr.xbrl.pojo package. This converter will be used to extract XBRL information from the database and send this information back to a validation engine, mapper, transformer or whatever other component of the architecture that is based on com.ihr.xbrl.om objects.
  Author:
    Ignacio

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLRSGenerator()` Instantiates a new XBRLRS generator.
    `XBRLRSGenerator(DTSContainer outDTS)` Instantiates a new XBRLRS generator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `XBRLArcroleType` | `generate(XBRLArcroleType arcrole, java.lang.String key)` Generate.
    `XMLElementDefinition` | `generate(XBRLConcept concept)` Generate.
    `XBRLContext` | `generate(XBRLContext context)` Generate.
    `XBRLDocument` | `generate(XBRLDocument doc)` Generate.
    `XBRLDocumentation` | `generate(XBRLDocumentation docIn, XBRLAllowsDocumentation parent)` Generate.
    `XBRLExtendedLink` | `generate(XBRLExtendedLink exLinkIn, XBRLDocument parent)` Generate.
    `XBRLFact` | `generate(XBRLFact fact, XBRLFactsList facts)` Generate.
    `XBRLImport` | `generate(XBRLImport importIn, XBRLTaxonomy parent)` Generate.
    `XBRLInstance` | `generate(XBRLInstance instanceIn)` Generate.
    `XBRLLinkbase` | `generate(XBRLLinkbase linkbaseIn)` Generate.
    `XBRLRelationship` | `generate(XBRLRelationship relIn)` Generate.
    `XBRLResource` | `generate(XBRLResource res)` Generate.
    `XBRLRoleType` | `generate(XBRLRoleType role, java.lang.String key)` Generate.
    `XBRLTaxonomy` | `generate(XBRLTaxonomy taxonomyIn)` Generate.
    `XBRLUsedOn` | `generate(XBRLUsedOn usedOnIn)` Generate.
    `XBRLAttribute` | `generate(XMLAttribute attribute)` Generate.
    `XMLFragment` | `generate(XMLFragment fragment)` Generate.
    `XBRLDocument` | `obtainFromDB(java.lang.String uri, org.hibernate.Session session)` Obtain from db.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XBRLRSGenerator

          public XBRLRSGenerator()

      Instantiates a new XBRLRS generator.

    - #### XBRLRSGenerator

          public XBRLRSGenerator(DTSContainer outDTS)

      Instantiates a new XBRLRS generator.
      Parameters:
        `outDTS` - the out dts

  - ### Method Detail

    - #### generate

          public XBRLInstance generate(XBRLInstance instanceIn)
                                throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `instanceIn` - the instance in
      Returns:
        the com.ihr.xbrl.om.instance. xbrl instance
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### obtainFromDB

          public XBRLDocument obtainFromDB(java.lang.String uri,
                                  org.hibernate.Session session)
                                    throws XBRLRSGeneratorException

      Obtain from db.
      Parameters:
        `uri` - the uri
        `session` - the session
      Returns:
        XBRLDocument
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLFact generate(XBRLFact fact,
                          XBRLFactsList facts)
                            throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `fact` - the fact
        `facts` - the facts
      Returns:
        the com.ihr.xbrl.om.instance. xbrl fact
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLContext generate(XBRLContext context)
                               throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `context` - the context
      Returns:
        XBRLContext
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLTaxonomy generate(XBRLTaxonomy taxonomyIn)
                                throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `taxonomyIn` - the taxonomy in
      Returns:
        the com.ihr.xbrl.om.taxonomy. xbrl taxonomy
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLImport generate(XBRLImport importIn,
                            XBRLTaxonomy parent)

      Generate.
      Parameters:
        `importIn` - the import in
        `parent` - the parent
      Returns:
        the com.ihr.xbrl.om.taxonomy. xbrl import

    - #### generate

          public XBRLLinkbase generate(XBRLLinkbase linkbaseIn)
                                throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `linkbaseIn` - the linkbase in
      Returns:
        the com.ihr.xbrl.om.ex links. xbrl linkbase
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLDocumentation generate(XBRLDocumentation docIn,
                                   XBRLAllowsDocumentation parent)

      Generate.
      Parameters:
        `docIn` - the doc in
        `parent` - the parent
      Returns:
        the com.ihr.xbrl.om.ex links. xbrl documentation

    - #### generate

          public XBRLExtendedLink generate(XBRLExtendedLink exLinkIn,
                                  XBRLDocument parent)
                                    throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `exLinkIn` - the ex link in
        `parent` - the parent
      Returns:
        the com.ihr.xbrl.om.ex links. xbrl extended link
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLRoleType generate(XBRLRoleType role,
                              java.lang.String key)
                                throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `role` - the role
        `key` - the key
      Returns:
        XBRLRoleType
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLUsedOn generate(XBRLUsedOn usedOnIn)
                              throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `usedOnIn` - the used on in
      Returns:
        the com.ihr.xbrl.om.taxonomy. xbrl used on
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLArcroleType generate(XBRLArcroleType arcrole,
                                 java.lang.String key)
                                   throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `arcrole` - the arcrole
        `key` - the key
      Returns:
        the com.ihr.xbrl.om.taxonomy. xbrl arcrole type
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLDocument generate(XBRLDocument doc)
                                throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `doc` - the doc
      Returns:
        the com.ihr.xbrl.om. xbrl document
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLRelationship generate(XBRLRelationship relIn)
                                    throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `relIn` - the rel in
      Returns:
        the com.ihr.xbrl.om.ex links. xbrl relationship
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLResource generate(XBRLResource res)
                                throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `res` - the res
      Returns:
        the com.ihr.xbrl.om.ex links. xbrl resource
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XMLElementDefinition generate(XBRLConcept concept)
                                        throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `concept` - the concept
      Returns:
        the com.ihr.xbrl.om.taxonomy. xml element definition
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XMLFragment generate(XMLFragment fragment)
                               throws XBRLRSGeneratorException

      Generate.
      Parameters:
        `fragment` - the fragment
      Returns:
        the com.ihr.xbrl.om. xml fragment
      Throws:
        `XBRLRSGeneratorException` - the XBRLRS generator exception

    - #### generate

          public XBRLAttribute generate(XMLAttribute attribute)

      Generate.
      Parameters:
        `attribute` - the attribute
      Returns:
        the com.ihr.xbrl.om. xbrl attribute